--- ices-0.4/src/in_mp4.c	2004-07-31 04:35:29.000000000 +0200
+++ ices-0.4-patched/src/in_mp4.c	2005-05-05 13:24:14.000000000 +0200
@@ -68,7 +68,61 @@
   if (! self->filesize)
     return 1;
 
-  if ((mp4file = MP4Read(self->path, 0)) == MP4_INVALID_FILE_HANDLE)
+  if ((mp4file = MP4Read(self->path, 0)) != MP4_INVALID_FILE_HANDLE) {
+    char *value;
+    char *artist = NULL, *title = NULL;
+    uint16_t numvalue, numvalue2;
+    if (MP4GetMetadataName(mp4file, &value) && value != NULL) {
+      ices_log_debug("Name: %s", value);
+      title = ices_util_strdup(value);
+      ices_util_free(value);
+    }
+    if (MP4GetMetadataArtist(mp4file, &value) && value != NULL) {
+      ices_log_debug("Artist: %s", value);
+      artist = ices_util_strdup(value);
+      ices_util_free(value);
+    }
+    if (MP4GetMetadataWriter(mp4file, &value) && value != NULL) {
+      ices_log_debug("Writer: %s", value);
+      ices_util_free(value);
+    }
+    if (MP4GetMetadataComment(mp4file, &value) && value != NULL) {
+      ices_log_debug("Comment: %s", value);
+      ices_util_free(value);
+    }
+    if (MP4GetMetadataTool(mp4file, &value) && value != NULL) {
+      ices_log_debug("Tool: %s", value);
+      ices_util_free(value);
+    }
+    if (MP4GetMetadataYear(mp4file, &value) && value != NULL) {
+      ices_log_debug("Year: %s", value);
+      ices_util_free(value);
+    }
+    if (MP4GetMetadataAlbum(mp4file, &value) && value != NULL) {
+      ices_log_debug("Album: %s", value);
+      ices_util_free(value);
+    }
+    if (MP4GetMetadataTrack(mp4file, &numvalue, &numvalue2)) {
+      ices_log_debug("Track: %u of %u", numvalue,
+	      numvalue2);
+    }
+    if (MP4GetMetadataDisk(mp4file, &numvalue, &numvalue2)) {
+      ices_log_debug("Disk: %u of %u", numvalue,
+	      numvalue2);
+    }
+    if (MP4GetMetadataGenre(mp4file, &value) && value != NULL) {
+      ices_log_debug("Genre: %s", value);
+      ices_util_free(value);
+    }
+    if (MP4GetMetadataTempo(mp4file, &numvalue)) {
+      ices_log_debug("Tempo: %u", numvalue);
+    }
+    ices_metadata_set(artist, title);
+    if (artist)
+       ices_util_free(artist);
+    if (title)
+       ices_util_free(title);
+  } else
     return 1;
 
   /* find audio stream */